<template>
  <label class="rick-morty" v-bind:class="classObject">
    <span class="rick-morty__label">{{ label }}</span>
    <div class="rick-morty__container">
      <input v-model="value" type="hidden" name="rick-morty-id" />
      <input
        v-model="inputValue"
        class="rick-morty__input"
        :placeholder="placeholder"
        @keyup="keyupListener"
      />
      <i class="rick-morty__icon"></i>
      <ul class="rick-morty__list">
        <li
          v-for="(item, index) in items"
          v-bind:key="index"
          class="rick-morty__item"
          @click="selectItem(item)"
        >
          <span
            class="rick-morty__item-name"
            v-html="highlightSearch(item.name)"
          ></span>
          <small
            class="rick-morty__item-category"
            v-html="`en ${highlightSearch(item.species)}`"
          ></small>
        </li>
      </ul>
    </div>
  </label>
</template>

<script>
import axios from "axios";
export default {
  name: "RickMortyAutocomplete",
  props: {
    label: {
      type: String,
      default: "Encuentra personajes de Rick&Morty",
    },
    placeholder: {
      type: String,
      default: "Quién buscas?",
    },
    delay: {
      type: Number,
      default: 600,
    },
    chars: {
      type: Number,
      default: 3,
    },
    max: {
      type: Number,
      default: 4,
    },
  },
  data: function () {
    return {
      value: "",
      inputValue: "",
      visible: false,
      loading: false,
      timer: 0,
      items: [],
    };
  },
  computed: {
    classObject: function () {
      return {
        "rick-morty--loading": this.loading,
        "rick-morty--visible": this.visible,
        "rick-morty--typing": this.inputValue.length,
      };
    },
  },
  mounted() {
    this.clickOutsideListener();
  },
  methods: {
    keyupListener(event) {
      if (this.visible) {
        event.preventDefault();
        const selected = event.target
          .closest(".rick-morty")
          .querySelector(".rick-morty__item--selected");
        const elements = event.target
          .closest(".rick-morty")
          .querySelectorAll(".rick-morty__item");
        let index = -1;
        let newIndex = 0;

        switch (event.which) {
          case 13: // enter
            if (selected) {
              selected.click();
            }
            break;
          case 27: // esc
            event.preventDefault();
            this.visible = false;
            this.loading = false;
            break;
          case 38: // up
            if (selected) {
              index = Array.from(elements).indexOf(selected);
              selected.classList.remove("rick-morty__item--selected");
            }
            newIndex =
              index - 1 < 0
                ? elements.length - 1
                : (index - 1) % elements.length;
            Array.from(elements)[newIndex].classList.add(
              "rick-morty__item--selected"
            );
            break;
          case 40: // down
            if (selected) {
              index = Array.from(elements).indexOf(selected);
              selected.classList.remove("rick-morty__item--selected");
            }
            newIndex = (index + 1) % elements.length;
            Array.from(elements)[newIndex].classList.add(
              "rick-morty__item--selected"
            );
            break;
          default:
            this.fetchItems();
        }
      } else {
        this.fetchItems();
      }
    },
    fetchItems() {
      if (this.inputValue && this.inputValue.length >= this.chars) {
        if (this.timer) {
          clearTimeout(this.timer);
        }

        var self = this;
        setTimeout(() => {
          self.loading = true;
          axios
            .get(
              `https://rickandmortyapi.com/api/character?name=${self.inputValue}`
            )
            .then((response) => {
              self.visible = true;
              self.loading = false;
              self.items = response.data.results.slice(0, self.max);
            })
            .catch((error) => {
              self.visible = false;
              self.loading = false;
              self.items = [];
            });
        }, this.delay);
      } else {
        this.items = [];
        this.visible = false;
        this.loading = false;
      }
    },
    highlightSearch(string) {
      const matches = string.match(new RegExp(this.inputValue, "ig"));
      if (matches) {
        matches.forEach((element) => {
          string = string.replace(element, `<b>${element}</b>`);
        });
      }
      return string;
    },
    clickOutsideListener() {
      var self = this;
      document.addEventListener("click", (event) => {
        if (!self.$el.contains(event.target)) {
          self.visible = false;
          self.loading = false;
        }
      });
    },
    selectItem(item) {
      this.value = item.id;
      this.inputValue = item.name;
      this.visible = false;
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped>
@font-face {
  font-family: "Avenir Next";
  src: local("Avenir Next Regular"), local("Avenir-Next-Regular"),
    url("../assets/AvenirNextCyr-Regular.woff2") format("woff2"),
    url("../assets/AvenirNextCyr-Regular.woff") format("woff"),
    url("../assets/AvenirNextCyr-Regular.ttf") format("truetype");
  font-weight: 400;
  font-style: normal;
}
@font-face {
  font-family: "Avenir Next Bold";
  src: local("Avenir Next Demi"), local("Avenir-Next-Demi"),
    url("../assets/AvenirNextCyr-Demi.woff2") format("woff2"),
    url("../assets/AvenirNextCyr-Demi.woff") format("woff"),
    url("../assets/AvenirNextCyr-Demi.ttf") format("truetype");
  font-weight: 600;
  font-style: normal;
}

@keyframes spin {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}

$background-light: #ffffff;
$background-dark: #fafafa;
$border-light: #d2d2d2;
$border-dark: #9b9b9b;
$text-light: #9b9b9b;
$text-dark: #757575;
$text-darker: #404040;
$shadow: rgba(255, 115, 0, 0.2);
$accent: #ff7300;
.rick-morty {
  font-family: "Avenir Next", sans-serif;
  text-align: left;
  font-size: 16px;
  display: inline-block;
  width: 100%;

  &__label {
    display: block;
    font-family: "Avenir Next Bold", sans-serif;
    line-height: 22px;
    margin-bottom: 8px;
  }

  &__container {
    position: relative;
  }

  &__input {
    width: 100%;
    background-color: $background-light;
    border: 1px solid $border-light;
    box-sizing: border-box;
    border-radius: 4px;
    line-height: 22px;
    outline: none;
    height: 48px;
    padding: 13px 56px 13px 15px;
    font-family: "Avenir Next", sans-serif;
    font-size: 1em;
    z-index: 2;
    position: relative;

    &:hover {
      border-color: $border-dark;
      background-color: $background-dark;
      border-color: $border-dark;
      box-shadow: none;
      &::placeholder {
        color: $text-dark;
      }
    }

    &--typing &,
    &:focus {
      border-color: $accent;
      background-color: $background-light;
      box-shadow: 0px 0px 8px $shadow;
    }

    &--loading & {
      border-color: $accent;
      background-color: $background-dark;
      box-shadow: 0px 0px 8px $shadow;
    }

    &::placeholder {
      color: $text-light;
      font-size: 1em;
    }
  }

  &__list {
    display: none;
    position: absolute;
    background-color: $background-light;
    border: 1px solid $border-light;
    border-top: 0px;
    box-sizing: border-box;
    border-radius: 0px 0px 4px 4px;
    width: 100%;
    padding: 3px 0px 0px 0px;
    margin: 16px 0px 0px 0px;
    list-style: none;
    z-index: 3;
    top: 2em;
  }

  &--visible & {
    &__list {
      display: block;
    }
  }

  &__item {
    min-height: 42px;
    line-height: 22px;
    padding: 11px 16px 9px 16px;
    margin-bottom: 0px;
    background-color: $background-light;
    box-sizing: border-box;

    &--selected,
    &:hover {
      background-color: $background-dark;
      cursor: pointer;
    }

    &:last-child {
      border-radius: 0px 0px 4px 4px;
    }
  }

  &__item-category {
    font-size: 15px;
    color: $text-light;
    display:inline;
    margin-left: 5px;
  }

  &__icon {
    position: absolute;
    top: 12px;
    right: 16px;
    height: 24px;
    width: 24px;
    mask: url(../assets/search.svg);
    mask-size: contain;
    mask-repeat: no-repeat;
    background-color: $text-dark;
    z-index: 3;
  }

  :focus + & {
    &__icon {
      background-color: $accent;
    }
  }

  &--loading & {
    &__icon {
      top: 13px;
      right: 16px;
      height: 22px;
      width: 22px;
      mask: url(../assets/loader.svg);
      background-color: $accent;
      animation: spin 1s infinite linear;
    }
  }
}
</style>
